# Copyright (c) 2003-2004 Chalmers University of Technology
# Authors: Jean-Marc Orliaguet <jmo@ita.chalmers.se>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as published
# by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.
#

__author__ = "Jean-Marc Orliaguet <jmo@ita.chalmers.se>"

""" CPSPortlets utilities """

import re

def html_slimmer(html):
    """Reduce the size of HTML code
    """
    html = re.sub(r'>\s+<','> <', html)
    html = re.sub(r'>\n+<','><', html)
    html = re.sub(r'>\s\s+','> ', html)
    html = re.sub(r'\s\s+<',' <', html)
    html = re.sub(r'\n\s+\n','', html)
    return html
