portlet_common_layout = {
    'widgets': {
        'visibility_range': {
            'type': 'CPS Portlet Visibility Widget',
            'data': {
                'fields': ('visibility_range',),
                'is_required': 0,
                'label_edit': 'cpsportlets_common_visibility_range_label',
                'is_i18n': True,
                'readonly_layout_modes': [],
                'hidden_layout_modes': ('view',),
                'hidden_readonly_layout_modes': [],
                'hidden_empty': 0,
                'hidden_if_expr': 'context/isGlobal',
                'vocabulary': 'cpsportlets_visibility_range_voc',
                'translated': True,
            },
        },
        'disable_override': {
            'type': 'Boolean Widget',
            'data': {
                'fields': ('disable_override',),
                'is_required': 0,
                'label_edit': 'cpsportlets_common_disable_override_label',
                'is_i18n': True,
                'readonly_layout_modes': [],
                'hidden_layout_modes': ('view',),
                'hidden_readonly_layout_modes': [],
                'hidden_empty': 0,
                'hidden_if_expr': 'context/isGlobal',
                'label_false': 'cpsschemas_label_false',
                'label_true': 'cpsschemas_label_true',
                'render_format': 'select',
            },
        },
        'Description': {
            'type': 'TextArea Widget',
            'data': {
                'fields': ('Description',),
                'is_required': 0,
                'label_edit': 'label_description',
                'is_i18n': True,
                'readonly_layout_modes': [],
                'hidden_layout_modes': ('view',),
                'hidden_readonly_layout_modes': [],
                'hidden_empty': 0,
                'hidden_if_expr': 'context/isGlobal',
                'width': 40,
                'height': 2,
                'render_format': 'text',
            },
        },
        'slot_override': {
            'type': 'Boolean Widget',
            'data': {
                'fields': ('slot_override',),
                'is_required': 0,
                'label_edit': 'cpsportlets_common_slot_override_label',
                'is_i18n': True,
                'readonly_layout_modes': [],
                'hidden_layout_modes': ('view',),
                'hidden_readonly_layout_modes': [],
                'hidden_empty': 0,
                'hidden_if_expr': 'context/isGlobal',
                'label_false': 'cpsschemas_label_false',
                'label_true': 'cpsschemas_label_true',
                'render_format': 'select',
            },
        },
        'Title': {
            'type': 'String Widget',
            'data': {
                'fields': ('Title',),
                'is_required': True,
                'label_edit': 'label_cpsportlets_title',
                'is_i18n': True,
                'readonly_layout_modes': [],
                'hidden_layout_modes': ('view',),
                'hidden_readonly_layout_modes': [],
                'hidden_empty': 0,
                'hidden_if_expr': 'context/isGlobal',
                'display_width': 36,
                'size_max': 36,
            },
        },
    },
    'layout': {
        'style_prefix': 'layout_portlet_',
        'flexible_widgets': [],
        'ncols': 4,
        'rows': [
            [{'widget_id': 'Title', 'ncols': 4},
            ],
            [{'widget_id': 'Description', 'ncols': 4},
            ],
            [{'widget_id': 'visibility_range', 'ncols': 4},
            ],
            [{'widget_id': 'slot_override', 'ncols': 3},
             {'widget_id': 'disable_override', 'ncols': 1},
            ],
        ],
    },
}

layouts = {'portlet_common': portlet_common_layout}
return layouts
